import { defineComponent, h, onBeforeUnmount, onMounted, ref } from "vue";
import { deepmerge as merge } from "deepmerge-ts";
// @ts-ignore
import { aplayer } from "@temp/SmplayerOptions.json";
export default defineComponent({
    props: {
        src: {
            type: Object,
            required: true,
        },
    },
    setup(props) {
        const el = ref(HTMLDivElement);
        const src = {
            ...merge(aplayer.src, props.src),
        };
        let player;
        const initAPlayer = () => {
            Promise.all([
                import("aplayer"),
                import("aplayer/dist/APlayer.min.css"),
            ]).then(([{ default: aplayer }]) => {
                (src.container = el.value), (player = new aplayer(src));
            });
        };
        const destroyAPlayer = () => {
            player.destroy();
        };
        onMounted(() => {
            initAPlayer();
        });
        onBeforeUnmount(() => {
            destroyAPlayer();
        });
        return () => [
            h("div", {
                id: "sb-aplayer",
                ref: el,
            }),
        ];
    },
});
